local AddonName, Hermes_MikSBT = ...

local LIB_AceAddon = LibStub("AceAddon-3.0") or error("Required library AceAddon-3.0 not found")
local Hermes = LibStub("AceAddon-3.0"):GetAddon("Hermes")
_G[AddonName] = LIB_AceAddon:NewAddon(Hermes_MikSBT, AddonName)
local MikSBT = nil

function Hermes_MikSBT:OnEnable()
	MikSBT = _G["MikSBT"]
end

function Hermes_MikSBT:OnDisable()
	
end

function Hermes_MikSBT:OnEnablePlugin()
	--wire up events
	Hermes:RegisterHermesEvent("OnAbilityInstanceStartCooldown", AddonName, function(instance) Hermes_MikSBT:OnAbilityInstanceStartCooldown(instance) end)
	Hermes:RegisterHermesEvent("OnAbilityInstanceStopCooldown", AddonName, function(instance) Hermes_MikSBT:OnAbilityInstanceStopCooldown(instance) end)
end

function Hermes_MikSBT:OnDisablePlugin()
	Hermes:UnregisterHermesEvent("OnAbilityInstanceStartCooldown", AddonName)
	Hermes:UnregisterHermesEvent("OnAbilityInstanceStopCooldown", AddonName)
end

function Hermes_MikSBT:OnInitialize()
	Hermes:RegisterHermesPlugin(
		AddonName,
		function() return self:OnEnablePlugin() end,
		function () return self:OnDisablePlugin() end,
		nil,
		nil
	)
end

function Hermes_MikSBT:OnAbilityInstanceStartCooldown(instance)
	if instance.sender.name ~= UnitName("Player") then
		Hermes_MikSBT:SendNotReadyMessage(instance.sender.name, instance.ability.name, instance.ability.icon, instance.sender.class)
	end
end

function Hermes_MikSBT:OnAbilityInstanceStopCooldown(instance)
	if instance.sender.name ~= UnitName("Player") then
		Hermes_MikSBT:SendReadyMessage(instance.sender.name, instance.ability.name, instance.ability.icon, instance.sender.class)
	end
end

function Hermes_MikSBT:SendNotReadyMessage(sender, name, icon, class)
	if MikSBT and not MikSBT.IsModDisabled() then
		MikSBT.DisplayMessage("|c"..Hermes:GetClassColorHEX(class)..sender.."|r (|T"..icon..":0:0:0:0|t"..name..")", MikSBT.DISPLAYTYPE_NOTIFICATION, nil, nil, nil, nil, nil, nil, nil, "Interface\\RAIDFRAME\\ReadyCheck-NotReady.blp")
	end
end

function Hermes_MikSBT:SendReadyMessage(sender, name, icon, class)
	if MikSBT and not MikSBT.IsModDisabled() then
		MikSBT.DisplayMessage("|c"..Hermes:GetClassColorHEX(class)..sender.."|r (|T"..icon..":0:0:0:0|t"..name..")", MikSBT.DISPLAYTYPE_NOTIFICATION, nil, nil, nil, nil, nil, nil, nil, "Interface\\RAIDFRAME\\ReadyCheck-Ready.blp")
	end
end
